Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QCollision.cc	(revision 1055)
@@ -1431,7 +1460,126 @@
       else G4cout<<"G4QCol::PSD: OUT, M2="<<s4M.m2()<<"<"<<minM*minM<<", N="<<nPDG<<G4endl;
 #endif
-    }
+     } // end of proton quasi-elastic (including QE on NF)
+     else // @@ make cost-condition @@ Pickup process (pickup 1 or 2 n and make d or t)
+     {
+       restPDG--;                // Res. nucleus PDG is one neutron less than targ. PDG
+       G4double mPUF=mDeut;      // Prototype of the mass of the created pickup fragment
+       G4ParticleDefinition* theDefinition = G4Deuteron::Deuteron();
+       //theDefinition = G4ParticleTable::GetParticleTable()->FindIon(nZ,nA,0,nZ);//ion
+       G4bool din=false;         // Flag of picking up 2 neutrons to create t (tritium)
+       //G4bool hin=false;         // Flag of picking up 1 n + 1 p to create He3 (NOT IMPL)
+       G4bool tin=false;         // Flag of picking up 2 n + 1 p to create alpha (He4)
+       G4double frn=G4UniformRand();
+       if(N>2 && frn > 0.95)      // .95 is a parameter to pickup 2n (cteate t or +1p=alph)
+       {
+         theDefinition = G4Triton::Triton();
+         restPDG--;              // Res. nucleus PDG is two neutrons less than target PDG
+         rA--;                   // Reduce the baryon number of the residual nucleus
+         mPUF=mTrit;             // The mass of the created pickup fragment (triton)
+         // Recalculate dmom
+         G4ThreeVector sumv=G4ThreeVector(0.,0.,dmom) +
+                       fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+         dmom=sumv.mag();
+         din=true;
+         if(Z>1 && frn > 0.99)  // 0.99 is a parameter to pickup 2n + 1p and create alpha
+         {
+           theDefinition = G4Alpha::Alpha();
+           restPDG-=1000;        // Res. nucleus PDG is (2 n + 1 p) less than target PDG
+           rA--;                 // Reduce the baryon number of the residual nucleus
+           rZ--;                 // Reduce the charge of the residual nucleus
+           mPUF=mAlph;           // The mass of the created pickup fragment (triton)
+           // Recalculate dmom
+           sumv += fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+           dmom=sumv.mag();
+           tin=true;
+         }
+       }
+       G4double mPUF2=mPUF*mPUF;
+       G4LorentzVector t4M(0.,0.,0.,tM);         // 4m of the target nucleus to be decayed
+       G4double rM=G4QPDGCode(restPDG).GetMass();// Mass of the residual nucleus
+       G4double rM2=rM*rM;                       // Squared mass of the residual nucleus
+       G4double nM2=rM2+tM*tM-(tM+tM)*std::sqrt(rM2+dmom*dmom);// M2 of boundQF-nucleon(2N)
+       if(nM2 < 0) nM2=0.;
+       G4double nM=std::sqrt(nM2);               // M of bQF-nucleon
+       G4double den2=(dmom*dmom+nM2);            // squared energy of bQF-nucleon
+       G4double den=std::sqrt(den2);             // energy of bQF-nucleon
+#ifdef qedebug
+       G4cout<<"G4QCollis::PStDoIt:PiU,p="<<dmom<<",tM="<<tM<<",R="<<rM<<",N="<<nM<<G4endl;
+#endif
+       G4double qp=momentum*dmom;
+       G4double srm=proj4M.e()*den;
+       G4double cost=(nM2+mProt2+srm+srm-mPUF2)/(qp+qp);
+       G4int ict=0;
+       while(std::fabs(cost)>1. && ict<3)
+       {
+         dmom=91.;  // Fermi momentum (proto default for a deuteron)
+         if(Z>1||N>1) dmom=fmm*std::pow(-std::log(G4UniformRand()),third);
+         if(din)          // Recalculate dmom for the final triton
+         {
+          G4ThreeVector sumv=G4ThreeVector(0.,0.,dmom) +
+                        fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+          if(tin) sumv+=fmm*std::pow(-std::log(G4UniformRand()),third)*G4RandomDirection();
+          dmom=sumv.mag();
+         }
+         nM2=rM2+tM*tM-(tM+tM)*std::sqrt(rM2+dmom*dmom); // M2 of bQF-nucleon
+         if(nM2 < 0) nM2=0.;
+         nM=std::sqrt(nM2);                      // M of bQF-nucleon
+         den2=(dmom*dmom+nM2);                   // squared energy of bQF-nucleon
+         den=std::sqrt(den2);                    // energy of bQF-nucleon
+         qp=momentum*dmom;
+         srm=proj4M.e()*den;
+         cost=(nM2+mProt2+srm+srm-mPUF2)/(qp+qp);
+         ict++;
+#ifdef ldebug
+         if(ict>2)G4cout<<"G4QCollis::PStDoIt:i="<<ict<<",d="<<dmom<<",ct="<<cost<<G4endl;
+#endif
+       }
+       if(std::fabs(cost)<=1.)
+       {// ---- @@ From here can be a MF for QF nucleon extraction (if used by others)
+        G4ThreeVector vdir = proj4M.vect();  // 3-Vector in the projectile direction
+        G4ThreeVector vx(0.,0.,1.);          // ProtoOrt in theDirection of the projectile
+        G4ThreeVector vy(0.,1.,0.);          // First ProtoOrt orthogonal to the direction
+        G4ThreeVector vz(1.,0.,0.);          // SecondProtoOrt orthoganal to the direction
+        if(vdir.mag2() > 0.)                 // the projectile isn't at rest
+        {
+          vx = vdir.unit();                  // Ort in the direction of the projectile
+          G4ThreeVector vv= vx.orthogonal(); // Not normed orthogonal vector (!)
+          vy = vv.unit();                    // First ort orthogonal to the proj direction
+          vz = vx.cross(vy);                 // Second ort orthoganal to the projDirection
+        }
+        // ---- @@ End of possible MF (Similar is in G4QEnvironment)
+        G4double tdom=dmom*std::sqrt(1-cost*cost);// Transversal component of the Fermi-Mom
+        G4double phi=twopi*G4UniformRand();  // Phi of the Fermi-Mom
+        G4ThreeVector vedm=vx*dmom*cost+vy*tdom*std::sin(phi)+vz*tdom*std::cos(phi);// bQFN
+        G4LorentzVector bqf(vedm,den);      // 4-mom of the bQF nucleon
+        r4M=t4M-bqf;                         // 4mom of the residual nucleus
+        if(std::fabs(r4M.m()-rM)>.001) G4cout<<"G4QCol::PSD:rM="<<rM<<"#"<<r4M.m()<<G4endl;
+        G4LorentzVector f4M=proj4M+bqf;      // Prototype of 4-mom of Deuteron
+        if(std::fabs(f4M.m()-mPUF)>.001)
+                              G4cout<<"G4QCol::PSD:mDeut="<<mPUF<<" # "<<f4M.m()<<G4endl;
+        aParticleChange.ProposeEnergy(0.);   // @@ ??
+        aParticleChange.ProposeTrackStatus(fStopAndKill);// projectile nucleon is killed
+        aParticleChange.SetNumberOfSecondaries(2); 
+        // Fill pickup hadron
+        G4DynamicParticle* theQFN = new G4DynamicParticle(theDefinition,f4M);
+        G4Track* scatQFN = new G4Track(theQFN, localtime, position ); //    pickup
+        scatQFN->SetWeight(weight);                                   //    weighted
+        scatQFN->SetTouchableHandle(trTouchable);                     //    nuclear
+        aParticleChange.AddSecondary(scatQFN);                        //    cluster
+        // ----------------------------------------------------
+        // Fill residual nucleus
+        if     (restPDG==90000001) theDefinition = G4Neutron::Neutron();
+        else if(restPDG==90001000) theDefinition = G4Proton::Proton();
+        else theDefinition = G4ParticleTable::GetParticleTable()->FindIon(rZ,rA,0,rZ);//ion
+        G4DynamicParticle* theReN = new G4DynamicParticle(theDefinition,r4M);
+        G4Track* scatReN = new G4Track(theReN, localtime, position ); //    scattered
+        scatReN->SetWeight(weight);                                   //    weighted
+        scatReN->SetTouchableHandle(trTouchable);                     //    residual
+        aParticleChange.AddSecondary(scatReN);                        //    nucleus
+        return G4VDiscreteProcess::PostStepDoIt(track, step);
+	 }
+     }
+    } // end of decoupled processes for the proton projectile
   }  // end lepto-nuclear, neutrino-nuclear, proton quasi-elastic
-
   EnMomConservation=proj4M+G4LorentzVector(0.,0.,0.,tM);    // Total 4-mom of the reaction
   if(absMom) EnMomConservation+=lead4M;         // Add E/M of leading System
@@ -1444,8 +1592,8 @@
   //G4double eWei=1.;
   // @@@@@@@@@@@@@@ Temporary for the testing purposes --- End  
-#ifdef debug
-  G4cout<<"G4QCollision::PostStepDoIt: projPDG="<<projPDG<<", targPDG="<<targPDG<<G4endl;
-#endif
-  G4QHadron* pH = new G4QHadron(projPDG,proj4M);                // ---> DELETED -->--  -+
+#ifdef ldebug
+  G4cout<<"^^G4QCollision::PostStepDoIt: projPDG="<<projPDG<<", targPDG="<<targPDG<<G4endl;
+#endif
+  G4QHadron* pH = new G4QHadron(projPDG,proj4M);                // ---> DELETED -->----+*
   //if(momentum<1000.) // Condition for using G4QEnvironment (not G4QuasmonString)      |
   { //                                                                                  |
@@ -1465,7 +1613,7 @@
     catch (G4QException& error)//                                                   |   .
     {                                                             //                |   .
-	     //#ifdef pdebug
+      //#ifdef pdebug
       G4cerr<<"***G4QCollision::PostStepDoIt: G4QE Exception is catched"<<G4endl;// |   .
-	     //#endif
+      //#endif
       G4Exception("G4QCollision::PostStepDoIt:","27",FatalException,"CHIPSCrash");//|   .
     }                                                             //                |   .
@@ -1483,10 +1631,10 @@
   //  try                                                           //                 |
   //  {                                                             //                 |
-  //		  delete output;                                  //                   |
+  //    delete output;                                  //                   |
   //    output = pan->Fragment();// DESTROYED in the end of the LOOP work space        |
   //    // @@@@@@@@@@@@@@ Temporary for the testing purposes --- Begin                 |
   //    //tNH=pan->GetNOfHadrons();     // For the test purposes of the String         |
   //    //if(tNH==2)                    // At least 2 hadrons are in the Constr.Output |
-  //	//{//                                                                          |
+  // //{//                                                                          |
   //    //  elF=true;                   // Just put a flag for the ellastic Scattering |
   //    //  delete output;              // Delete a prototype of dummy G4QHadronVector |
@@ -1503,5 +1651,5 @@
   //    //#ifdef pdebug
   //    G4cerr<<"***G4QCollision::PostStepDoIt: GEN Exception is catched"<<G4endl; //  |
-	 //    //#endif
+  //    //#endif
   //    G4Exception("G4QCollision::PostStDoIt:","27",FatalException,"QString Excep");//|
   //  }                                                             //                 |
@@ -1524,6 +1672,4 @@
     delete leadhs;
   }
-
-
   // ------------- From here the secondaries are filled -------------------------
   G4int tNH = output->size();       // A#of hadrons in the output
@@ -1565,5 +1711,5 @@
     {
 #ifdef debug
-	     G4cout<<"G4QCollision::PostStepDoIt: Intermediate particle is found i="<<i<<G4endl;
+      G4cout<<"G4QCollision::PostStepDoIt: Intermediate particle is found i="<<i<<G4endl;
 #endif
       delete hadr;
@@ -1578,5 +1724,5 @@
     {
       if(G4UniformRand()>.5) theDefinition = G4KaonZeroLong::KaonZeroLong();   // K_L
-						else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
+      else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
     }
     else if(PDGCode==91000999) theDefinition = G4SigmaPlus::SigmaPlus();
@@ -1585,10 +1731,10 @@
     else if(PDGCode==91999999) theDefinition = G4XiZero::XiZero();
     else if(PDGCode==92998999) theDefinition = G4OmegaMinus::OmegaMinus();
-	   else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
+    else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
     {
       G4int aZ = hadr->GetCharge();
       G4int aA = hadr->GetBaryonNumber();
 #ifdef pdebug
-						G4cout<<"G4QCollision::PostStepDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
+      G4cout<<"G4QCollision::PostStepDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
 #endif
       theDefinition = G4ParticleTable::GetParticleTable()->FindIon(aZ,aA,0,aZ);
@@ -1598,9 +1744,9 @@
     {
 #ifdef pdebug
-						G4cout<<"G4QCollision::PostStepDoIt:Define particle with PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QCollision::PostStepDoIt:Define particle with PDG="<<PDGCode<<G4endl;
 #endif
       theDefinition = G4QPDGToG4Particle::Get()->GetParticleDefinition(PDGCode);
 #ifdef pdebug
-						G4cout<<"G4QCollision::PostStepDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QCollision::PostStepDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
 #endif
     }
@@ -1643,5 +1789,5 @@
   delete output; // instances of the G4QHadrons from the output are already deleted above +
 #ifdef debug
-		G4cout<<"G4QCollision::PostStDoIt: after St="<<aParticleChange.GetTrackStatus()<<G4endl;
+  G4cout<<"G4QCollision::PostStDoIt: after St="<<aParticleChange.GetTrackStatus()<<G4endl;
 #endif
   if(aProjPDG!=11 && aProjPDG!=13 && aProjPDG!=15)
@@ -1649,9 +1795,9 @@
   //return &aParticleChange;                               // This is not enough (ClearILL)
 #ifdef pdebug
-		  G4cout<<"G4QCollision::PostStepDoIt: E="<<aParticleChange.GetEnergy()
+    G4cout<<"G4QCollision::PostStepDoIt: E="<<aParticleChange.GetEnergy()
           <<", d="<<*aParticleChange.GetMomentumDirection()<<G4endl;
 #endif
-#ifdef debug
-		G4cout<<"G4QCollision::PostStepDoIt:*** PostStepDoIt is done ***, P="<<aProjPDG<<", St="
+#ifdef ldebug
+  G4cout<<"G4QCollision::PostStepDoIt:*** PostStepDoIt is done ***, P="<<aProjPDG<<", St="
         <<aParticleChange.GetTrackStatus()<<G4endl;
 #endif
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffraction.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffraction.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QDiffraction.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4QDiffraction.cc,v 1.5 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QDiffraction.cc,v 1.6 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QDiffraction class -----------------
@@ -31,7 +31,14 @@
 // G4QDiffraction class of the CHIPS Simulation Branch in GEANT4
 // ---------------------------------------------------------------
-// ****************************************************************************************
-// ********** This CLASS is temporary moved from the "chips/interface" directory *********
-// ****************************************************************************************
+// Short description: This is a process, which describes the diffraction
+// excitation of the projectile and the nucleus. On nuclei in addition there
+// can be a coherent diffraction process for the projectile, but it is
+// comparably small. The most important part of the diffraction is the
+// progectile diffraction excitation, as in this interaction proton can lose
+// only a small part of its energy and make the shower longer. This is because
+// only 1-2 (n) pions are produce in the diffraction escitation, and the mean
+// kept energy of the nucleon is (1-n/7)=80%. For kaons the kept energy is much
+// smaller (1-n/3.5)=60%, and for pions it is less important (about 40%).
+// ----------------------------------------------------------------------------
 
 //#define debug
@@ -144,10 +151,10 @@
                                          <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
           G4double abund=abuVector[j];
-								  std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
+          std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
 #ifdef debug
           G4cout<<"G4QDiffract::GetMeanFreePath:pair#"<<j<<",N="<<N<<",ab="<<abund<<G4endl;
 #endif
           newAbund->push_back(pr);
-						  }
+        }
 #ifdef debug
         G4cout<<"G4QDiffract::GetMeanFreePath:pairVectorLength="<<newAbund->size()<<G4endl;
@@ -176,5 +183,5 @@
       G4cout<<"G4QDiff::GMFP:true,P="<<Momentum<<",Z="<<Z<<",N="<<N<<",PDG="<<pPDG<<G4endl;
 #endif
-		    G4bool ccsf=true;
+      G4bool ccsf=true;
       if(Q==-27.) ccsf=false;
 #ifdef debug
@@ -250,5 +257,5 @@
   static G4bool CWinit = true;                       // CHIPS Warld needs to be initted
   if(CWinit)
-		{
+  {
     CWinit=false;
     G4QCHIPSWorld::Get()->GetParticles(nPartCWorld); // Create CHIPS World (234 part.max)
@@ -323,5 +330,5 @@
 #ifdef debug
   G4int prPDG=particle->GetPDGEncoding();
-		G4cout<<"G4QDiffraction::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
+  G4cout<<"G4QDiffraction::PostStepDoIt: projPDG="<<projPDG<<", stPDG="<<prPDG<<G4endl;
 #endif
   if(!projPDG)
@@ -339,8 +346,8 @@
     fPDG=2212;
   }
-		// Element treatment
+  // Element treatment
   G4int EPIM=ElProbInMat.size();
 #ifdef debug
-		G4cout<<"G4QDiffra::PostStDoIt: m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
+  G4cout<<"G4QDiffra::PostStDoIt: m="<<EPIM<<",n="<<nE<<",T="<<ElProbInMat[EPIM-1]<<G4endl;
 #endif
   G4int i=0;
@@ -349,7 +356,7 @@
     G4double rnd = ElProbInMat[EPIM-1]*G4UniformRand();
     for(i=0; i<nE; ++i)
-		  {
-#ifdef debug
-				  G4cout<<"G4QDiffra::PostStepDoIt: EPM["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
+    {
+#ifdef debug
+      G4cout<<"G4QDiffra::PostStepDoIt: EPM["<<i<<"]="<<ElProbInMat[i]<<",r="<<rnd<<G4endl;
 #endif
       if (rnd<ElProbInMat[i]) break;
@@ -360,5 +367,5 @@
   Z=static_cast<G4int>(pElement->GetZ());
 #ifdef debug
-				G4cout<<"G4QDiffraction::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
+    G4cout<<"G4QDiffraction::PostStepDoIt: i="<<i<<", Z(element)="<<Z<<G4endl;
 #endif
   if(Z<=0)
@@ -371,5 +378,5 @@
   G4int nofIsot=SPI->size();               // #of isotopes in the element i
 #ifdef debug
-		G4cout<<"G4QDiffraction::PostStepDoIt: nI="<<nofIsot<<", T="<<(*SPI)[nofIsot-1]<<G4endl;
+  G4cout<<"G4QDiffraction::PostStepDoIt: nI="<<nofIsot<<", T="<<(*SPI)[nofIsot-1]<<G4endl;
 #endif
   G4int j=0;
@@ -380,5 +387,5 @@
     {
 #ifdef debug
-				  G4cout<<"G4QDiffraction::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<",r="<<rndI<<G4endl;
+      G4cout<<"G4QDiffraction::PostStepDoIt: SP["<<j<<"]="<<(*SPI)[j]<<",r="<<rndI<<G4endl;
 #endif
       if(rndI < (*SPI)[j]) break;
@@ -388,5 +395,5 @@
   G4int N =(*IsN)[j]; ;                    // Randomized number of neutrons
 #ifdef debug
-		G4cout<<"G4QDiffraction::PostStepDoIt: j="<<i<<", N(isotope)="<<N<<", MeV="<<MeV<<G4endl;
+  G4cout<<"G4QDiffraction::PostStepDoIt: j="<<i<<", N(isotope)="<<N<<", MeV="<<MeV<<G4endl;
 #endif
   if(N<0)
@@ -470,10 +477,10 @@
   G4QHadronVector* out=diffRatio->TargFragment(projPDG, proj4M, Z, N);
   G4int nSec=out->size();             // #of secondaries in the diffraction reaction
-		G4DynamicParticle* theSec=0;        // A prototype for secondary for the secondary
+  G4DynamicParticle* theSec=0;        // A prototype for secondary for the secondary
   G4LorentzVector dif4M(0.,0.,0.,0.); // Prototype for the secondary 4-momentum
   G4int difPDG=0;                     // PDG code of the secondary
   G4QHadron* difQH=0;                 // Prototype for a Q-secondary
 #ifdef pdebug
-		G4cout<<"G4QDiffraction::PostStepDoIt: =====found===== nSecondaries="<<nSec<<G4endl;
+  G4cout<<"G4QDiffraction::PostStepDoIt: =====found===== nSecondaries="<<nSec<<G4endl;
 #endif
   for(G4int i=0; i<nSec; i++)
@@ -522,10 +529,10 @@
       theDefinition = G4ParticleTable::GetParticleTable()->FindIon(Z,B,0,0);
 #ifdef pdebug
-		    G4cout<<"G4QDiffraction::PoStDoIt:Ion,Z="<<Z<<",A="<<B<<",D="<<theDefinition<<G4endl;
+      G4cout<<"G4QDiffraction::PoStDoIt:Ion,Z="<<Z<<",A="<<B<<",D="<<theDefinition<<G4endl;
 #endif
     }
     if(theDefinition)
     {
-    		theSec = new G4DynamicParticle;       // A secondary for the recoil hadron 
+      theSec = new G4DynamicParticle;       // A secondary for the recoil hadron 
       theSec->SetDefinition(theDefinition);
       dif4M  = difQH->Get4Momentum();
@@ -537,5 +544,5 @@
       aParticleChange.AddSecondary( aNewTrack );
 #ifdef pdebug
-		    G4cout<<"G4QDiffraction::PostStepDoIt: Filled 4M="<<dif4M<<", PDG="<<difPDG<<G4endl;
+      G4cout<<"G4QDiffraction::PostStepDoIt: Filled 4M="<<dif4M<<", PDG="<<difPDG<<G4endl;
 #endif
     }
@@ -568,5 +575,5 @@
   G4double s=diffRatio->GetTargSingDiffXS(p, PDG, Z, N);     // XS for target diffraction
 #ifdef debug
-		G4cout<<"G4QDiff::CXS:p="<<p<<",Z="<<Z<<",N="<<N<<",C="<<PDG<<",XS="<<s<<G4endl;
+  G4cout<<"G4QDiff::CXS:p="<<p<<",Z="<<Z<<",N="<<N<<",C="<<PDG<<",XS="<<s<<G4endl;
 #endif
   return s;
